From 637b75f9320df8f2e52fcdfa2cf0c9de5f0d1f8f Mon Sep 17 00:00:00 2001
From: rafaelrabetti <rafael.rabetti@gmail.com>
Date: Oct 03 2017 20:46:09 +0000
Subject: [PATCH 3/6] Create page see some package analysis

- Creating a component to select a analyzer and some improvements
- Updating test configuration to suport polifyll
- Updating table data and integrate to analysis screen
- Integrating graphics in analysis screen
- Fixing package page layout for large screens
- Fixing frontend to analyser page

Signed-off-by: matheusgodinho <matheus.godinho@outlook.com>
Signed-off-by: thiagocmoreira <thiago.cmoreira@yahoo.com.br>
Signed-off-by: eduardonunes <eduardonunes2525@gmail.com>
Signed-off-by: rafaelrabetti <rafael.rabetti@gmail.com>

---

diff --git a/src/App.vue b/src/App.vue
index ea74cf1..15a6666 100644
--- a/src/App.vue
+++ b/src/App.vue
@@ -10,7 +10,7 @@ import Vue from 'vue'
 import VueMaterial from 'vue-material'
 import 'vue-material/dist/vue-material.css'
 import Vuex from 'vuex'
-import HeaderK from './components/shared/HeaderK.vue'
+import HeaderK from './components/shared/HeaderK'
 
 Vue.use(VueMaterial)
 Vue.use(Vuex)
diff --git a/src/components/home/Home.vue b/src/components/home/Home.vue
index 44d1d4c..29c3971 100644
--- a/src/components/home/Home.vue
+++ b/src/components/home/Home.vue
@@ -8,6 +8,7 @@
 import List from '../packages/List.vue'
 
 export default {
+  name: 'home',
   components: {
     'list-packages': List
   }
diff --git a/src/components/package/ErrorsTable.vue b/src/components/package/ErrorsTable.vue
new file mode 100644
index 0000000..1579cf9
--- /dev/null
+++ b/src/components/package/ErrorsTable.vue
@@ -0,0 +1,100 @@
+<template>
+<div>
+  <b-card header-tag="header" footer-tag="footer">
+    <!-- <h6 slot="header" class="mb-0">
+            <div class="my-1 row">
+                <div class="col-md-6">
+                    <b-form-fieldset horizontal label="Rows per page" :label-cols="6">
+                        <b-form-select :options="pageOptions" v-model="perPage" />
+                        </b-form-fieldset>
+                    </div>
+                    <div class="col-md-6">
+                        <b-form-fieldset horizontal label="Filter" :label-cols="3">
+                            <b-form-input v-model="filter" placeholder="Type to Search" />
+                            </b-form-fieldset>
+                        </div>
+                    </div>
+                </h6> -->
+    <em slot="footer">
+      <b-pagination align="center" :total-rows="totalRows" :per-page="perPage" v-model="currentPage"/>
+    </em>
+    <p class="card-text">
+      <b-table striped hover show-empty
+      :items="correctList"
+      :fields="fields"
+      :current-page="currentPage"
+      :per-page="perPage"
+      :sort-by.sync="sortBy"
+      :sort-desc.sync="sortDesc"
+      ></b-table>
+    </p>
+  </b-card>
+</div>
+</template>
+
+<script>
+import { mapGetters } from 'vuex'
+import * as getterNames from '../../store/getterNames.js'
+
+export default {
+  data () {
+    return {
+      fields: {
+        type: {
+          label: 'Type',
+          sortable: true,
+          'class': 'text-center'
+        },
+        path: {
+          label: 'Path',
+          sortable: true
+        },
+        line: {
+          label: 'Line : Column'
+        },
+        message: {
+          label: 'Message'
+        }
+      },
+      totalRows: this.total,
+      currentPage: 1,
+      perPage: 10,
+      sortBy: 'type',
+      sortDesc: false
+    }
+  },
+  computed: {
+    ...mapGetters([
+      getterNames.errorsList
+    ]),
+    total () {
+      return this.errorsList.length
+    },
+    correctList () {
+      return this.makeErrorsTable()
+    }
+  },
+  methods: {
+    makeErrorsTable () {
+      let errorsList = this.errorsList.map((errorsObject) => {
+        const returnError = {}
+        returnError.type = errorsObject.testid
+        if (errorsObject.location) {
+          const lineColumn = `${errorsObject.location.point.line} : ${errorsObject.location.point.column}`
+          returnError.path = errorsObject.location.file.givenpath
+          returnError.line = lineColumn
+        }
+        if (errorsObject.message) {
+          returnError.message = errorsObject.message.text
+        }
+        return returnError
+      })
+      return errorsList
+    },
+    onFiltered (filteredItems) {
+      this.totalRows = filteredItems.length
+      this.currentPage = 1
+    }
+  }
+}
+</script>
diff --git a/src/components/package/PackagePage.vue b/src/components/package/PackagePage.vue
new file mode 100644
index 0000000..d0a1be1
--- /dev/null
+++ b/src/components/package/PackagePage.vue
@@ -0,0 +1,124 @@
+<template>
+  <div class="package-page container">
+    <div class="card container">
+      <div class="row">
+        <div class="col-sm-6 description-container">
+          <summary-package :package="package" class="summary" />
+          <p> Selecione um analizador para verificar os erros: </p>
+          <b-dropdown id="ddown1" :text= "analizers[selectedAnalizer].name" variant="primary" class="m-md-2">
+            <b-dropdown-item v-for="(analizer, index) in analizers" key="'dropdown' + index" @click="onSelectAnalizer(index)"> {{ analizer.name }} </b-dropdown-item>
+          </b-dropdown>
+        </div>
+        <div class="col-sm-6 graph-container">
+          <p> Erros do analizador {{ analizers[selectedAnalizer].name }}: </p>
+          <p> Total: {{ total }} </p>
+          <pie-chart :data="datasets" class="graph" />
+        </div>
+      </div>
+    </div>
+    <errors-table />
+  </div>
+</template>
+
+<script>
+import { mapActions, mapGetters } from 'vuex'
+import * as actionTypes from '../../store/actionTypes.js'
+import * as getterNames from '../../store/getterNames.js'
+import SummaryPackage from './SummaryPackage'
+import ErrorsTable from './ErrorsTable'
+import PieChart from './PieChart'
+
+export default {
+  components: {
+    SummaryPackage,
+    ErrorsTable,
+    PieChart
+  },
+  props: {
+    package: {
+      type: Object,
+      default () {
+        return {}
+      }
+    }
+  },
+  data () {
+    return {
+      selectedAnalizer: 0
+    }
+  },
+  computed: {
+    ...mapGetters([
+      getterNames.analizers,
+      getterNames.reports
+    ]),
+    datasets () {
+      const labels = Object.keys(this.reports)
+      const data = labels.map((key) => {
+        return this.reports[key]
+      })
+      const datasets = [{
+        label: 'Errors',
+        data: data,
+        backgroundColor: ['#CC0000', '#ffbb33', '#0099CC']
+      }]
+      return { labels, datasets }
+    },
+    total () {
+      const labels = Object.keys(this.reports)
+      const data = labels.map((key) => {
+        return this.reports[key]
+      })
+
+      return data.reduce(function (a, b) { return a + b }, 0)
+    }
+  },
+  methods: {
+    ...mapActions([
+      actionTypes.SET_SELECTED
+    ]),
+    onSelectAnalizer (index) {
+      this.selectedAnalizer = index
+      this.setSelected(index)
+    }
+  }
+}
+</script>
+
+<style lang="scss" scoped>
+.package-page {
+  margin-top: 20px;
+}
+
+.card {
+  margin-bottom: 20px;
+}
+
+.description-container {
+  display: flex;
+  flex-direction: column;
+  align-items: center;
+  p {
+    text-align: center;
+  }
+}
+
+.graph-container {
+  padding-top: 2vh;
+  display: flex;
+  flex-direction: column;
+  justify-content: center;
+  p {
+    text-align: center;
+  }
+}
+
+.summary {
+  margin-top: 15px;
+}
+
+.graph {
+  padding: 10px 0;
+  margin: 0 auto;
+}
+</style>
diff --git a/src/components/package/PieChart.vue b/src/components/package/PieChart.vue
new file mode 100644
index 0000000..83ddc06
--- /dev/null
+++ b/src/components/package/PieChart.vue
@@ -0,0 +1,30 @@
+<template>
+ <div>
+  <pie-chart :data="data" :options="options"></pie-chart>
+ </div>
+</template>
+
+<script>
+import PieChart from '../../helpers/Charts.js'
+export default {
+  components: {
+    'pie-chart': PieChart
+  },
+  props: {
+    data: {
+      type: Object,
+      required: true
+    },
+    options: {
+      type: Object,
+      required: false
+    }
+  }
+}
+</script>
+
+<style lang="scss" scoped>
+  div {
+    max-width: 300px;
+  }
+</style>
\ No newline at end of file
diff --git a/src/components/package/SummaryPackage.vue b/src/components/package/SummaryPackage.vue
new file mode 100644
index 0000000..a7e7394
--- /dev/null
+++ b/src/components/package/SummaryPackage.vue
@@ -0,0 +1,32 @@
+<template>
+  <b-card class="summary-package"  bg-variant="dark" text-variant="white" :title="package.name">
+    <p class="card-text"> {{ package.version }} </p>
+    <p> {{ package.lastUpdate }} </p>
+  </b-card>
+</template>
+
+<script>
+export default {
+  props: {
+    package: {
+      type: Object,
+      default () {
+        return {
+          name: 'Some name',
+          version: 'Some version',
+          lastUpdate: '26/09/2017'
+        }
+      }
+    }
+  }
+}
+</script>
+
+<style lang="scss" scoped>
+.summary-package {
+  width: 30%;
+  max-width: 300px;
+  min-width: 250px;
+  height: 40%;
+}
+</style>
diff --git a/src/components/packages/List.vue b/src/components/packages/List.vue
index 2bd3015..961b30d 100644
--- a/src/components/packages/List.vue
+++ b/src/components/packages/List.vue
@@ -33,8 +33,8 @@ export default {
     ...mapActions([
       actionTypes.FETCH_PACKAGES
     ]),
-    showPackage () {
-      // show the analysis here
+    showPackage (value) {
+      this.$router.push({ name: 'analysis', params: { package: value } })
     }
   },
   created () {
diff --git a/src/components/shared/HeaderK.vue b/src/components/shared/HeaderK.vue
index dab3cca..fd7b1d7 100644
--- a/src/components/shared/HeaderK.vue
+++ b/src/components/shared/HeaderK.vue
@@ -1,27 +1,27 @@
 <template>
-    <b-navbar toggleable="md" type="light" variant="light">
-        <b-nav-toggle target="nav_text_collapse" />
-        <b-navbar-brand href='#'>
-            <h2>
-                <img src="../../assets/kiskadee_logo.png" width="35" height="35" class="d-inline-block align-top" alt="logo">
-                {{say_my_name}}
-            </h2>
-        </b-navbar-brand>
-        <b-collapse is-nav id="nav_text_collapse">
-            <b-nav is-nav-bar>
-                <!--<b-nav-item href="#">Packages List</b-nav-item>-->
-            </b-nav>
-        </b-collapse>
-    </b-navbar>
+  <b-navbar toggleable="md" type="light" variant="light" class="navbar">
+    <b-nav-toggle target="nav_text_collapse" />
+    <b-navbar-brand href="home" class="logo">
+      <img src="../../assets/kiskadee_logo.png" width="35" height="35" class="d-inline-block align-top" alt="logo">
+      <router-link :to="{ name: 'home' }">
+        <h2 class="name">{{ say_my_name }}</h2>
+      </router-link>
+    </b-navbar-brand>
+    <b-collapse is-nav id="nav_text_collapse">
+      <b-nav is-nav-bar>
+      </b-nav>
+    </b-collapse>
+  </b-navbar>
 </template>
 
 <script>
 export default {
-    data () {
-        return {
-            say_my_name: 'Kiskadee'
-        }
+  name: 'header-kiskadee',
+  data () {
+    return {
+      say_my_name: 'Kiskadee'
     }
+  }
 }
 
 </script>
@@ -30,8 +30,26 @@ export default {
 @import url('https://fonts.googleapis.com/css?family=Comfortaa:700');
 
 a:link, a:visited {
-    font-family: 'Comfortaa', cursive;
-    color: #3e6eb3;
-    text-decoration: none;
+  font-family: 'Comfortaa', cursive;
+  color: #3e6eb3;
+  text-decoration: none;
+}
+
+.navbar {
+  height: 55px;
+}
+
+.name {
+  display: inline-block;
+  marging-top: 10px;
+}
+
+.name:hover {
+  color: #072c62;
+}
+
+.logo {
+  padding-top: 15px;
+  text-decoration: none !important;
 }
 </style>
diff --git a/src/router/routes.js b/src/router/routes.js
index 183a362..6d317bb 100644
--- a/src/router/routes.js
+++ b/src/router/routes.js
@@ -1,5 +1,7 @@
 import Home from '../components/home/Home.vue'
+import PackagePage from '../components/package/PackagePage.vue'
 
 export const routes = [
-  { path: '', component: Home }
+  { name: 'home', path: '', component: Home },
+  { name: 'analysis', path: '/analysis/', component: PackagePage, props: route => ({package: route.params.package}) }
 ]
diff --git a/src/store/actionTypes.js b/src/store/actionTypes.js
index bf553e5..3fc18bc 100644
--- a/src/store/actionTypes.js
+++ b/src/store/actionTypes.js
@@ -1 +1,5 @@
+// Packages
 export const FETCH_PACKAGES = 'fetchPackages'
+
+// Analysis
+export const SET_SELECTED = 'setSelected'
diff --git a/src/store/getterNames.js b/src/store/getterNames.js
index f1e1aba..105c853 100644
--- a/src/store/getterNames.js
+++ b/src/store/getterNames.js
@@ -1 +1,7 @@
+// Packages
 export const allPackages = 'allPackages'
+
+// Analysis
+export const analizers = 'analizers'
+export const reports = 'reports'
+export const errorsList = 'errorsList'
diff --git a/src/store/index.js b/src/store/index.js
index 066bf2c..2b4a4c9 100644
--- a/src/store/index.js
+++ b/src/store/index.js
@@ -1,9 +1,11 @@
 import Vuex from 'vuex'
 
 import packages from './modules/packages'
+import analisys from './modules/analysis'
 
 export default new Vuex.Store({
   modules: {
-    packages
+    packages,
+    analisys
   }
 })
diff --git a/src/store/modules/analysis.js b/src/store/modules/analysis.js
new file mode 100644
index 0000000..62c578b
--- /dev/null
+++ b/src/store/modules/analysis.js
@@ -0,0 +1,376 @@
+import * as actionTypes from '../actionTypes'
+import * as getterNames from '../getterNames'
+import * as mutationTypes from '../mutationsTypes'
+
+const state = {
+  analysis: [
+    {
+      'analyzer_id': 1,
+      'id': 1,
+      'raw': {
+        'customfields': null,
+        'metadata': {
+          'file_': null,
+          'generator': {
+            'name': 'cppcheck',
+            'version': '1.80'
+          },
+          'stats': null,
+          'sut': null
+        },
+        'results': [
+          {
+            'customfields': null,
+            'cwe': null,
+            'location': {
+              'file': {
+                'abspath': null,
+                'givenpath': 'source/active_children.c',
+                'hash_': null
+              },
+              'function': null,
+              'point': {
+                'column': 0,
+                'line': 42
+              },
+              'range_': null
+            },
+            'message': {
+              'text': 'Unused variable: stdin_descriptor'
+            },
+            'notes': null,
+            'severity': 'style',
+            'testid': 'unusedVariable',
+            'trace': null,
+            'type': 'Issue'
+          },
+          {
+            'customfields': null,
+            'cwe': null,
+            'location': {
+              'file': {
+                'abspath': null,
+                'givenpath': 'source/father.c',
+                'hash_': null
+              },
+              'function': null,
+              'point': {
+                'column': 0,
+                'line': 43
+              },
+              'range_': null
+            },
+            'message': {
+              'text': 'The scope of the variable \'times\' can be reduced.'
+            },
+            'notes': {
+              'text': `The scope of the variable 'times' can be reduced. Warning: Be careful when fixing this message, especially when there are inner loops. Here is an example where cppcheck will write that the scope for 'i' can be reduced:\\012void f(int x)\\012{\\012    int i = 0;\\012    if (x) {\\012        // it's safe to move 'int i = 0;' here\\012        for (int n = 0; n < 10; ++n) {\\012            // it is possible but not safe to move 'int i = 0;' here\\012            do_something(&i);\\012        }\\012    }\\012}\\012When you see this message it is always safe to reduce the variable scope 1 level.`
+            },
+            'severity': 'style',
+            'testid': 'variableScope',
+            'trace': null,
+            'type': 'Issue'
+          },
+          {
+            'customfields': null,
+            'cwe': null,
+            'location': {
+              'file': {
+                'abspath': null,
+                'givenpath': 'source/father.c',
+                'hash_': null
+              },
+              'function': null,
+              'point': {
+                'column': 0,
+                'line': 45
+              },
+              'range_': null
+            },
+            'message': {
+              'text': `The scope of the variable 'complete_msg_sleepy' can be reduced.`
+            },
+            'notes': {
+              'text': `The scope of the variable 'complete_msg_sleepy' can be reduced. Warning: Be careful when fixing this message, especially when there are inner loops. Here is an example where cppcheck will write that the scope for 'i' can be reduced:\\012void f(int x)\\012{\\012    int i = 0;\\012    if (x) {\\012        // it's safe to move 'int i = 0;' here\\012        for (int n = 0; n < 10; ++n) {\\012            // it is possible but not safe to move 'int i = 0;' here\\012            do_something(&i);\\012        }\\012    }\\012}\\012When you see this message it is always safe to reduce the variable scope 1 level.`
+            },
+            'severity': 'style',
+            'testid': 'variableScope',
+            'trace': null,
+            'type': 'Issue'
+          },
+          {
+            'customfields': null,
+            'cwe': null,
+            'location': {
+              'file': {
+                'abspath': null,
+                'givenpath': 'source/father.c',
+                'hash_': null
+              },
+              'function': null,
+              'point': {
+                'column': 0,
+                'line': 46
+              },
+              'range_': null
+            },
+            'message': {
+              'text': `The scope of the variable 'complete_msg_active' can be reduced.`
+            },
+            'notes': {
+              'text': `The scope of the variable 'complete_msg_active' can be reduced. Warning: Be careful when fixing this message, especially when there are inner loops. Here is an example where cppcheck will write that the scope for 'i' can be reduced:\\012void f(int x)\\012{\\012    int i = 0;\\012    if (x) {\\012        // it's safe to move 'int i = 0;' here\\012        for (int n = 0; n < 10; ++n) {\\012            // it is possible but not safe to move 'int i = 0;' here\\012            do_something(&i);\\012        }\\012    }\\012}\\012When you see this message it is always safe to reduce the variable scope 1 level.`
+            },
+            'severity': 'style',
+            'testid': 'variableScope',
+            'trace': null,
+            'type': 'Issue'
+          },
+          {
+            'customfields': null,
+            'cwe': null,
+            'location': {
+              'file': {
+                'abspath': null,
+                'givenpath': 'source/father.c',
+                'hash_': null
+              },
+              'function': null,
+              'point': {
+                'column': 0,
+                'line': 77
+              },
+              'range_': null
+            },
+            'message': {
+              'text': `The scope of the variable 'seconds' can be reduced.`
+            },
+            'notes': {
+              'text': `The scope of the variable 'seconds' can be reduced. Warning: Be careful when fixing this message, especially when there are inner loops. Here is an example where cppcheck will write that the scope for 'i' can be reduced:\\012void f(int x)\\012{\\012    int i = 0;\\012    if (x) {\\012        // it's safe to move 'int i = 0;' here\\012        for (int n = 0; n < 10; ++n) {\\012            // it is possible but not safe to move 'int i = 0;' here\\012            do_something(&i);\\012        }\\012    }\\012}\\012When you see this message it is always safe to reduce the variable scope 1 level.`
+            },
+            'severity': 'style',
+            'testid': 'variableScope',
+            'trace': null,
+            'type': 'Issue'
+          },
+          {
+            'customfields': null,
+            'cwe': null,
+            'location': {
+              'file': {
+                'abspath': null,
+                'givenpath': 'source/father.c',
+                'hash_': null
+              },
+              'function': null,
+              'point': {
+                'column': 0,
+                'line': 114
+              },
+              'range_': null
+            },
+            'message': {
+              'text': 'Uninitialized variable: readbuffer_active'
+            },
+            'notes': null,
+            'severity': 'error',
+            'testid': 'uninitvar',
+            'trace': null,
+            'type': 'Issue'
+          },
+          {
+            'customfields': null,
+            'cwe': null,
+            'location': {
+              'file': {
+                'abspath': null,
+                'givenpath': 'source/main.c',
+                'hash_': null
+              },
+              'function': null,
+              'point': {
+                'column': 0,
+                'line': 14
+              },
+              'range_': null
+            },
+            'message': {
+              'text': 'Uninitialized variable: sleepy_children'
+            },
+            'notes': null,
+            'severity': 'error',
+            'testid': 'uninitvar',
+            'trace': null,
+            'type': 'Issue'
+          },
+          {
+            'customfields': null,
+            'cwe': null,
+            'location': {
+              'file': {
+                'abspath': null,
+                'givenpath': 'source/main.c',
+                'hash_': null
+              },
+              'function': null,
+              'point': {
+                'column': 0,
+                'line': 14
+              },
+              'range_': null
+            },
+            'message': {
+              'text': 'Uninitialized variable: active_children'
+            },
+            'notes': null,
+            'severity': 'error',
+            'testid': 'uninitvar',
+            'trace': null,
+            'type': 'Issue'
+          },
+          {
+            'customfields': null,
+            'cwe': null,
+            'location': {
+              'file': {
+                'abspath': null,
+                'givenpath': 'source/sleepy_children.c',
+                'hash_': null
+              },
+              'function': null,
+              'point': {
+                'column': 0,
+                'line': 30
+              },
+              'range_': null
+            },
+            'message': {
+              'text': `The scope of the variable 'time_to_sleep' can be reduced.`
+            },
+            'notes': {
+              'text': `The scope of the variable 'time_to_sleep' can be reduced. Warning: Be careful when fixing this message, especially when there are inner loops. Here is an example where cppcheck will write that the scope for 'i' can be reduced:\\012void f(int x)\\012{\\012    int i = 0;\\012    if (x) {\\012        // it's safe to move 'int i = 0;' here\\012        for (int n = 0; n < 10; ++n) {\\012            // it is possible but not safe to move 'int i = 0;' here\\012            do_something(&i);\\012        }\\012    }\\012}\\012When you see this message it is always safe to reduce the variable scope 1 level.`
+            },
+            'severity': 'style',
+            'testid': 'variableScope',
+            'trace': null,
+            'type': 'Issue'
+          },
+          {
+            'customfields': null,
+            'cwe': null,
+            'location': {
+              'file': {
+                'abspath': null,
+                'givenpath': 'source/sleepy_children.c',
+                'hash_': null
+              },
+              'function': null,
+              'point': {
+                'column': 0,
+                'line': 28
+              },
+              'range_': null
+            },
+            'message': {
+              'text': 'Unused variable: readbuffer_sleepy'
+            },
+            'notes': null,
+            'severity': 'style',
+            'testid': 'unusedVariable',
+            'trace': null,
+            'type': 'Issue'
+          },
+          {
+            'customfields': {
+              'verbose': `Cppcheck cannot find all the include files. Cppcheck can check the code without the include files found. But the results will probably be more accurate if all the include files are found. Please check your project's include directories and add all of them as include directories for Cppcheck. To see what files Cppcheck cannot find use --check-config.`
+            },
+            'failureid': 'missingIncludeSystem',
+            'location': null,
+            'message': {
+              'text': 'Cppcheck cannot find all the include files (use --check-config for details)'
+            },
+            'type': 'Failure'
+          }
+        ]
+      },
+      'report': {
+        'analysis_id': 1,
+        'errors': 3,
+        'id': 1,
+        'styles': 7,
+        'warnings': 0
+      },
+      'version_id': 1
+    },
+    {
+      'analyzer_id': 2,
+      'id': 1,
+      'raw': {
+        'customfields': null,
+        'metadata': {
+          'file_': null,
+          'generator': {
+            'name': 'outro',
+            'version': '2.22'
+          },
+          'stats': null,
+          'sut': null
+        },
+        'results': []
+      },
+      'report': {
+        'analysis_id': 2,
+        'errors': 4,
+        'id': 2,
+        'styles': 10,
+        'warnings': 3
+      },
+      'version_id': 2
+    }
+  ],
+  selectedAnalyzer: 1
+}
+
+const getters = {
+  [getterNames.analizers]: (state) => {
+    return state.analysis.map((analizer) => {
+      return {
+        id: analizer.analyzer_id,
+        name: analizer.raw.metadata.generator.name,
+        version: analizer.raw.metadata.generator.version
+      }
+    })
+  },
+  [getterNames.reports]: (state) => {
+    return state.analysis.filter((analyzer) => {
+      return analyzer.analyzer_id === state.selectedAnalyzer
+    }).map((analizer) => {
+      return {
+        errors: analizer.report.errors,
+        warnings: analizer.report.warnings,
+        styles: analizer.report.styles
+      }
+    })[0]
+  },
+  [getterNames.errorsList]: (state) => {
+    return state.analysis.filter((analyzer) => analyzer.analyzer_id === state.selectedAnalyzer).map((analyzer) => analyzer.raw.results)[0]
+  }
+}
+
+const actions = {
+  async [actionTypes.SET_SELECTED] ({commit, getters, state}, id) {
+    commit(mutationTypes.STORE_SELECTED, id)
+  }
+}
+
+const mutations = {
+  [mutationTypes.STORE_SELECTED] (state, id) {
+    state.selectedAnalyzer = id
+  }
+}
+
+export default {
+  state,
+  getters,
+  actions,
+  mutations
+}
diff --git a/src/store/modules/packages.js b/src/store/modules/packages.js
index a85b18f..3253825 100644
--- a/src/store/modules/packages.js
+++ b/src/store/modules/packages.js
@@ -1,10 +1,29 @@
-import api from '../../api/packages'
+// import api from '../../api/packages'
 import * as actionTypes from '../actionTypes'
 import * as getterNames from '../getterNames'
 import * as mutationTypes from '../mutationsTypes'
 
 const state = {
-  allPackages: []
+  allPackages: [
+    {
+      name: 'Teste',
+      version: '1.0.1',
+      upstream: 'http://www.google.com',
+      lastUpdate: '17/09/2017'
+    },
+    {
+      name: 'Pacote de dados',
+      version: '1.0.2',
+      upstream: 'http://www.google.com',
+      lastUpdate: '17/09/2017'
+    },
+    {
+      name: 'Fedora Package',
+      version: '0.3.8',
+      upstream: 'http://www.google.com',
+      lastUpdate: '17/09/2017'
+    }
+  ]
 }
 
 const getters = {
@@ -15,8 +34,8 @@ const getters = {
 
 const actions = {
   async [actionTypes.FETCH_PACKAGES] ({commit, getters, state}) {
-    let { data } = await api.get()
-    commit(mutationTypes.STORE_PACKAGES, data)
+    // let { data } = await api.get()
+    // commit(mutationTypes.STORE_PACKAGES, data)
   }
 }
 
@@ -25,7 +44,7 @@ const mutations = {
     state.allPackages = data.packages.map((pkg) => {
       return {
         name: pkg.name,
-        last_version: pkg.versions[0].number
+        lastVersion: pkg.versions[0].number
       }
     })
   }
diff --git a/src/store/mutationsTypes.js b/src/store/mutationsTypes.js
index fca80de..123b673 100644
--- a/src/store/mutationsTypes.js
+++ b/src/store/mutationsTypes.js
@@ -1 +1,5 @@
+// Packages
 export const STORE_PACKAGES = 'STORE_PACKAGES'
+
+// Analysis
+export const STORE_SELECTED = 'STORE_SELECTED'
diff --git a/test/unit/karma.conf.js b/test/unit/karma.conf.js
index 8e4951c..560de5b 100644
--- a/test/unit/karma.conf.js
+++ b/test/unit/karma.conf.js
@@ -14,7 +14,7 @@ module.exports = function (config) {
     browsers: ['PhantomJS'],
     frameworks: ['mocha', 'sinon-chai', 'phantomjs-shim'],
     reporters: ['spec', 'coverage'],
-    files: ['./index.js'],
+    files: ['../../node_modules/babel-polyfill/dist/polyfill.js', './index.js'],
     preprocessors: {
       './index.js': ['webpack', 'sourcemap']
     },
diff --git a/test/unit/specs/Home.spec.js b/test/unit/specs/Home.spec.js
new file mode 100644
index 0000000..a2f24a9
--- /dev/null
+++ b/test/unit/specs/Home.spec.js
@@ -0,0 +1,11 @@
+import Vue from 'vue'
+import App from '../../../src/App.vue'
+
+describe('App.vue', () => {
+  it('should render correct contents to navbar title', () => {
+    const Constructor = Vue.extend(App)
+    const vm = new Constructor().$mount()
+    expect(vm.$el.querySelector('#app > nav > a > h2').textContent)
+      .to.equal('Kiskadee')
+  })
+})
